Attribute VB_Name = "Module1"
Option Explicit
Option Base 1
Sub DoItAgain()
Application.OnTime Now + TimeValue("01:01:00"), "GetNewData"
End Sub
Sub GetNewData(Again As Boolean)
Dim NextRow As Integer, NextRank As Long, UnitsLeft As Integer
Dim NextLeft As Integer

Application.ScreenUpdating = False

RefreshSheets ("BAXL")
RefreshSheets ("BAXL Kindle")
RefreshSheets ("Stats")
RefreshSheets ("Stats Kindle")

NextRow = ThisWorkbook.Sheets("Summary").Cells(30000, 1).End(xlUp).Row + 1

Application.Calculation = xlCalculationManual

ThisWorkbook.Sheets("Summary").Cells(NextRow, 1) = Now

With ThisWorkbook.Sheets("Summary")

    NextRank = GetRank("Stats", " in")
    .Cells(NextRow, 2) = NextRank
    NextLeft = GetUnitsLeft("Stats")
    If NextLeft <> -1 Then
        .Cells(NextRow, 21) = NextLeft
    End If
    
    NextRank = GetRank("Stats Kindle", " Paid in")
    .Cells(NextRow, 7) = NextRank
    
    NextRank = GetRank("BAXL", " in")
    .Cells(NextRow, 3) = NextRank
    NextLeft = GetUnitsLeft("BAXL")
    If NextLeft <> -1 Then
        .Cells(NextRow, 22) = NextLeft
    End If
    
    NextRank = GetRank("BAXL Kindle", " Paid in")
    .Cells(NextRow, 8) = NextRank
    
    .Activate
        
    .Range(.Cells(NextRow - 1, 11), .Cells(NextRow - 1, 19)).Select
    Selection.AutoFill Destination:=.Range(.Cells(NextRow - 1, 11), .Cells(NextRow, 19)), Type:=xlFillDefault
    .Rows(NextRow + 1).Select
    Selection.Insert Shift:=xlDown
    .Cells(NextRow, 1).Select
    
    Application.Calculation = xlCalculationAutomatic
    
End With
ThisWorkbook.Save
Application.ScreenUpdating = True

End Sub

Function GetRank(SheetName As String, TrailingString As String) As Long

Dim FoundString As String
Dim StartPos As Integer, StopPos As Integer
On Error GoTo EarlyOut
Sheets(SheetName).Activate
Cells.Find(What:="sellers Rank:", After:=ActiveCell, LookIn:= _
    xlFormulas, LookAt:=xlPart, SearchOrder:=xlByRows, SearchDirection:= _
    xlNext, MatchCase:=False).Activate
FoundString = ActiveCell
StartPos = InStr(FoundString, " #") + 2

StopPos = InStr(StartPos, FoundString, TrailingString)

GetRank = 1 * Mid(FoundString, StartPos, StopPos - StartPos)
Exit Function
EarlyOut:
GetRank = 0
End Function

Function GetUnitsLeft(SheetName As String) As Long

Dim FoundString As String
Dim StartPos As Integer, StopPos As Integer
GetUnitsLeft = -1
Sheets(SheetName).Activate
On Error GoTo Nodata
Cells.Find(What:="left in stock", After:=ActiveCell, LookIn:= _
    xlFormulas, LookAt:=xlPart, SearchOrder:=xlByRows, SearchDirection:= _
    xlNext, MatchCase:=False).Activate

FoundString = ActiveCell
StartPos = InStr(FoundString, "Only ")
StopPos = InStr(StartPos + 4, FoundString, " in")
GetUnitsLeft = 1 * Mid(FoundString, StartPos + 5, StopPos - StartPos - 9)
Exit Function
Nodata:
On Error Resume Next

End Function

Sub RefreshSheets(SheetName As String)
With ThisWorkbook
    With .Sheets(SheetName)
        .Activate
        .Cells(1, 1).Select
        Selection.QueryTable.Refresh BackgroundQuery:=False
    End With
End With
End Sub

